#include "StdAfx.h"
#include "Client.h"

#using <..\\Debug\\Eneter.Messaging.Framework.dll>
using namespace Eneter::Messaging::EndPoints::TypedMessages;

using namespace System;
using namespace Eneter::Messaging::MessagingSystems::MessagingSystemBase;
using namespace Eneter::Messaging::MessagingSystems::TcpMessagingSystem;

Client::Client(const wchar_t* address)
{
    myAddress = gcnew String(address);
    IDuplexTypedMessagesFactory^ aSenderFactory = gcnew DuplexTypedMessagesFactory(TimeSpan::FromSeconds(5));
    mySender = aSenderFactory->CreateSyncDuplexTypedMessageSender<ResponseMessage^, RequestMessage^>();
}


Client::~Client(void)
{
    CloseConnection();
}

void Client::OpenConnection()
{
    // Let's use TCP.
    // (But other protocols would work too.)
    IMessagingSystemFactory^ aMessaging = gcnew TcpMessagingSystemFactory();
    IDuplexOutputChannel^ anOutputChannel = aMessaging->CreateDuplexOutputChannel(myAddress);

    // Attach the channel and be able to send request messages
    // and receive responses.
    mySender->AttachDuplexOutputChannel(anOutputChannel);
}

void Client::CloseConnection()
{
    // Detach the output channel.
    // Note: It releases the thread listening to responses.
    mySender->DetachDuplexOutputChannel();
}

int Client::SendCalculateRequest(int a, int b)
{
    RequestMessage^ aRequest = gcnew RequestMessage;
    aRequest->Number1 = a;
    aRequest->Number2 = b;

    ResponseMessage^ aResponse = mySender->SendRequestMessage(aRequest);

    return aResponse->Result;
}

