#pragma once

#include <string>
#include <vcclr.h>
#include "CommunicationApi.h"

#using <..\\Debug\\Eneter.Messaging.Framework.dll>

using namespace System;
using namespace Eneter::Messaging::EndPoints::TypedMessages;

// Request message declared as managed class.
public ref class RequestMessage
{
public:
    int Number1;
    int Number2;
};

// Response message declared as managed class.
public ref class ResponseMessage
{
public:
    int Result;
};


// Client declared as NATIVE class to be able to derive
// from IClient.
class Client : public IClient
{
public:
    Client(const wchar_t* address);
    virtual ~Client();

    virtual void OpenConnection();
    virtual void CloseConnection();
    virtual int SendCalculateRequest(int a, int b);

private:
    gcroot<String^> myAddress;
    gcroot<ISyncDuplexTypedMessageSender<ResponseMessage^, RequestMessage^> ^> mySender;
};

